<?php

use PrestaShop\PrestaShop\Core\Stock\StockManager;

class WebserviceSpecificManagementSyncstock implements WebserviceSpecificManagementInterface{
    protected $objOutput;
    protected $output;
 
    /** @var WebserviceRequest */
    protected $wsObject;

    public function setUrlSegment($segments){
        $this->urlSegment = $segments;
        return $this;
    }
     
    public function getUrlSegment(){
        return $this->urlSegment;
    }
     
    public function getWsObject(){
        return $this->wsObject;
    }
     

    public function getObjectOutput(){
        return $this->objOutput;
    }
    
    /**
    * This must be return a string with specific values as WebserviceRequest expects.
    *
    * @return string
    */
    public function getContent(){
        return $this->objOutput->getObjectRender()->overrideContent($this->output);
    }
     
    public function setWsObject(WebserviceRequestCore $obj){
        $this->wsObject = $obj;
        return $this;
    }
     
    /**
    * @param WebserviceOutputBuilderCore $obj
    * @return WebserviceSpecificManagementInterface
    */ 
    public function setObjectOutput(WebserviceOutputBuilderCore $obj){
        $this->objOutput = $obj;
        return $this;
    }
     
    public function manage(){
        $objects_products = array();
        $objects_products['empty'] = new Product();
        $body = json_decode(Tools::file_get_contents('php://input'));
        $headers = getallheaders();
        if(isset($headers['Authorization'])){
            $token=Configuration::get("SMARTBILL_API_TOKEN");
            if(!empty($token) && !empty($headers['Authorization']) && $headers['Authorization'] == 'Bearer '.$token){
                if(is_null($body)){
                    $output=$this->getObjectOutput();
                    $output->setStatus(400);
                    $this->setObjectOutput($output);
                    $this->output ='Eroare sintaxa. Verifica valididatea JSON-ulului trimis.';
                }else{
                    $this->smartbill_prestashop_stocks_update($body);
                }
            }else{
                $file = __DIR__.DIRECTORY_SEPARATOR.'smartbill_sincronizare_stocuri.log';
                if(file_exists($file)){
                    error_log("======================================================================================================================================".PHP_EOL,3, $file);
                }
                $this->smartbill_prestashop_log($body,"Authentication failed when PRODUCTS RECEIVED");
                $output=$this->getObjectOutput();
                $output->setStatus(403);
                $this->setObjectOutput($output);
                $this->output ="Autentificare esuata. Asigura-te ca tokenul folosit pentru trimiterea notificarii de stoc este corect si ca serverul tau permite autentificarea prin headers.";
      
            }
        }else{
            $file = __DIR__.DIRECTORY_SEPARATOR.'smartbill_sincronizare_stocuri.log';;
            if(file_exists($file)){
                error_log("======================================================================================================================================".PHP_EOL,3, $file);
            }
            $this->smartbill_prestashop_log($body,"Authentication failed when PRODUCTS RECEIVED");
            $output=$this->getObjectOutput();
            $output->setStatus(403);
            $this->setObjectOutput($output);
            $this->output ="Autentificare esuata. Asigura-te ca tokenul folosit pentru trimiterea notificarii de stoc este corect si ca serverul tau permite autentificarea prin headers.";
        }

      
    }


    public function smartbill_prestashop_get_product_stocks_data_by_name($productName,$skuType){
        $productName=pSQL($productName);
        $skuType=pSQL($skuType);       
        if($skuType!="product_id"){
            //Cauta produs fara cod referinta (ps_product)
            $product_id=Db::getInstance()->getValue('SELECT '._DB_PREFIX_.'product_lang.id_product, '._DB_PREFIX_.'product_lang.name, '._DB_PREFIX_.'product.'.$skuType.' FROM '._DB_PREFIX_.'product INNER JOIN '._DB_PREFIX_.'product_lang ON '._DB_PREFIX_.'product.id_product = '._DB_PREFIX_.'product_lang.id_product WHERE LEFT('._DB_PREFIX_.'product_lang.name,LENGTH('._DB_PREFIX_.'product_lang.name))=LEFT("'.$productName.'",LENGTH('._DB_PREFIX_.'product_lang.name)) AND  '._DB_PREFIX_.'product.'.$skuType.'=""');

            if(!$product_id){
                //Cauta produs cu combinatii fara cod referinta (ps_product_attribute)
                $product_id=Db::getInstance()->getValue('SELECT '._DB_PREFIX_.'product_lang.id_product, '._DB_PREFIX_.'product_lang.name, '._DB_PREFIX_.'product_attribute.'.$skuType.' FROM '._DB_PREFIX_.'product_attribute INNER JOIN '._DB_PREFIX_.'product_lang ON '._DB_PREFIX_.'product_attribute.id_product = '._DB_PREFIX_.'product_lang.id_product WHERE LEFT('._DB_PREFIX_.'product_lang.name,LENGTH('._DB_PREFIX_.'product_lang.name))=LEFT("'.$productName.'",LENGTH('._DB_PREFIX_.'product_lang.name)) AND '._DB_PREFIX_.'product_attribute.'.$skuType.'=""');
            }
        }else{
            $product_id=Db::getInstance()->getValue('SELECT '._DB_PREFIX_.'product_lang.id_product, '._DB_PREFIX_.'product_lang.name FROM '._DB_PREFIX_.'product_attribute INNER JOIN '._DB_PREFIX_.'product_lang ON '._DB_PREFIX_.'product_attribute.id_product = '._DB_PREFIX_.'product_lang.id_product WHERE LEFT('._DB_PREFIX_.'product_lang.name,LENGTH('._DB_PREFIX_.'product_lang.name))=LEFT("'.$productName.'",LENGTH('._DB_PREFIX_.'product_lang.name))');
        }

        $id_attribute=0;
        if($product_id){
            $product_obj = new Product((int) $product_id);
            
            $combinations=$product_obj->getWsCombinations();
            foreach ($combinations as $comb){
                $combination=$product_obj->getAttributeCombinationsById((int)$comb['id'],1);
                    $comb_attr=$product_obj->name[1].' -';
                    for ($i = 0; $i < count($combination); $i++){
                        $separator = Configuration::get('PS_ATTRIBUTE_ANCHOR_SEPARATOR');
                        if($i!=count($combination)-1){
                            $comb_attr=$comb_attr.' '.trim($combination[$i]['group_name'])." : ".trim($combination[$i]['attribute_name'].$separator);
                        }else{
                            $comb_attr=$comb_attr.' '.trim($combination[$i]['group_name'])." : ".trim($combination[$i]['attribute_name']);
                        }
            }
                    if($comb_attr==$productName){
                            $id_attribute=$comb['id'];
                            break;
                    }
            }  
        }
        
        return [$product_id, $id_attribute];
    }



    public function smartbill_prestashop_get_product_stocks_data_by_ref($productCode,$skuType,$productName){
        $productCode=pSQL($productCode);
        $skuType=pSQL($skuType);
        $productName=pSQL($productName);
        $id_attribute=0;
        if($skuType!="product_id"){
            $product_id=Db::getInstance()->getValue('SELECT id_product FROM '._DB_PREFIX_.'product WHERE '.$skuType.' ="'.$productCode.'";');
            
            if($product_id){
                $product_obj = new Product((int) $product_id);
                if($product_obj->hasCombinations()){
                    $product_id_attribute=Db::getInstance()->getValue('SELECT id_product FROM '._DB_PREFIX_.'product_attribute WHERE reference ="'.$productCode.'";');
                    if($product_id_attribute==$product_id){
                        //SKU duplicate found
                        $product_id=null;
                    }
                }
                
            }else{
                $product_id=Db::getInstance()->getValue('SELECT id_product FROM '._DB_PREFIX_.'product_attribute WHERE '.$skuType.' ="'.$productCode.'";');
                $product_obj = new Product((int) $product_id);
                $id_lang = Context::getContext()->language->id;
                $combinations = $product_obj->getAttributeCombinations((int)$id_lang, true);
                foreach ($combinations as $combination){
                    if($combination[$skuType]==$productCode){
                        $id_attribute=$combination['id_product_attribute'];
                        break;
                    }
                }
            }

        }else{
            $product_id=$productCode;
            $product_obj = new Product((int) $product_id);
            
            $combinations=$product_obj->getWsCombinations();
            foreach ($combinations as $comb){
                $combination=$product_obj->getAttributeCombinationsById((int)$comb['id'],1);
                    $comb_attr=$product_obj->name[1].' -';
                    for ($i = 0; $i < count($combination); $i++){
                        $separator = Configuration::get('PS_ATTRIBUTE_ANCHOR_SEPARATOR');
                        if($i!=count($combination)-1){
                            $comb_attr=$comb_attr.' '.trim($combination[$i]['group_name'])." : ".trim($combination[$i]['attribute_name'].$separator);
                        }else{
                            $comb_attr=$comb_attr.' '.trim($combination[$i]['group_name'])." : ".trim($combination[$i]['attribute_name']);
                        }
                    }
                    if($comb_attr==$productName){
                            $id_attribute=$comb['id'];
                            break;
                    }
            }  
        }
      
        return [$product_id, $id_attribute];
       
    }


    function smartbill_prestashop_stocks_update($products){
        $options=SmartBillSettings::get_config_fields_values();
        $skuType=$options['SMARTBILL_PRODUCT_SKU_TYPE'];
        if (!empty($options) && is_array($options) && isset($options['SMARTBILL_USED_STOCK'])) {
            $selected_stock = $options['SMARTBILL_USED_STOCK'];
            if (empty($selected_stock) || $selected_stock == 'fara-gestiune'){
                $selected_stock = false;
                echo('"Eroare actualizare stoc. Gestiunea monitorizata nu a fost setata in modulul SmartBill."'.PHP_EOL);
            }
        } else {
            $selected_stock = false;
            echo('"Eroare actualizare stoc. Gestiunea monitorizata nu a fost setata in modulul SmartBill."'.PHP_EOL);
        }

        $file = __DIR__.DIRECTORY_SEPARATOR.'smartbill_sincronizare_stocuri.log';
        if(file_exists($file)){
            error_log("======================================================================================================================================".PHP_EOL,3, $file);
        }

        if(isset($products->products)){
            $products=$products->products;
            $this->smartbill_prestashop_log($products,"PRODUCTS RECEIVED");
            if(is_array($products)){
                if(count($products)==0){
                    echo('"Testul de sincronizare stoc a fost facut cu succes!"'.PHP_EOL); 
                }

                $this->smartbill_prestashop_log("START STOCK SYNC","INFO");
                foreach($products as $product){
                    $temp=$product->warehouse;
                    if ($selected_stock!=false && strtolower($temp) == strtolower($selected_stock)){
                        if(!isset($product->productCode) || empty($product->productCode)){
                            $product_data=$this->smartbill_prestashop_get_product_stocks_data_by_name($product->productName,$skuType);
                            if(empty($product_data[0])){
                                echo('"Eroare actualizare stoc. Produsul cu numele '.$product->productName.' nu a fost gasit in nomenclatorul Prestashop."'.PHP_EOL);
                                $this->smartbill_prestashop_log("Product with product name $product->productName not found!","ERROR");   
                            }
                        }else{
                            $product_data=$this->smartbill_prestashop_get_product_stocks_data_by_ref(trim($product->productCode),$skuType,$product->productName); 
                            if(empty($product_data[0])){
                                echo('"Eroare actualizare stoc. Produsul cu codul '.$product->productCode.' nu a fost gasit in nomenclatorul Prestashop."'.PHP_EOL);  
                                $this->smartbill_prestashop_log("Product with product code $product->productCode not found!","ERROR");  
                            }
                        }
        
                        if(!empty($product_data[0])){

                            if(!isset($product->productCode) || empty($product->productCode)){
                                $this->smartbill_prestashop_log("Product $product->productName has been found by name. Attempting to update stocks.","INFO");
                            }else{
                                $this->smartbill_prestashop_log("Product $product->productName has been found by sku: $product->productCode. Attempting to update stocks.","INFO");
                            }

                            try{
                                $product_obj= new Product((int)$product_data[0]);

                                $reserved_stock  = StockManagerFactory::getManager()->getProductRealQuantities((int)$product_data[0], (int) $product_data[1], 0, true);
                                $available_stock = StockAvailable::getQuantityAvailableByProduct((int)$product_data[0], (int) $product_data[1]);
                                $stock_manager = new StockManager();
                                $stock_manager->updateQuantity($product_obj, (int) $product_data[1], (int)$product->quantity + ($reserved_stock-$available_stock) );
                               
                                $date = new DateTime('now');
                                $date->setTimezone(new DateTimeZone(Configuration::get('PS_TIMEZONE')));
                                Configuration::updateValue( 'SMARTBILL_STOCK_UPDATE', serialize( $date ) );

                                $this->smartbill_prestashop_log("Quantity of product ".$product->productName." with id ".$product_data[0]." has been updated to ". $product->quantity.".","INFO");             
                                if(!isset($product->productCode) || empty($product->productCode)){
                                    echo('"Stoc actualizat pentru produsul cu id-ul '.$product_data[0].' si numele '.$product->productName.'. Stoc nou: '. $product->quantity.'"'.PHP_EOL);
                                }else{
                                    echo('"Stoc actualizat pentru produsul cu id-ul '.$product_data[0].' si codul '.$product->productCode.'. Stoc nou: '. $product->quantity.'"'.PHP_EOL);
                                }

                            }catch(Exception $e){
                                if(!isset($product->productCode) || empty($product->productCode)){
                                    $this->smartbill_prestashop_log("Couldn't update stocks for product ".$product->productName."!" ,"ERROR");
                                }else{
                                    $this->smartbill_prestashop_log("Couldn't update stocks for product ".$product->productName." with sku: ".$product->productCode."!" ,"ERROR"); 
                                }
                                echo('"'.$e->getMessage().'"'.PHP_EOL);
                            }
                        }

                    }else{
                        $this->smartbill_prestashop_log( "Plugin configured warehouse: ".$selected_stock." doesn't match received product warehouse: ".$temp,"ERROR");
                        echo('"Eroare actualizare stoc. Gestiune configurata in modul: '.$selected_stock.'. Gestiunea produsului '.$product->productName.': '.$temp.'"'.PHP_EOL); 
                    }
                }
                $this->smartbill_prestashop_log("STOP STOCK SYNC","INFO");
             
            }
        }else{
            $this->smartbill_prestashop_log($products,"INVALID PRODUCTS");
        }
    }


    function smartbill_prestashop_log($message,$type){
        $file = __DIR__.DIRECTORY_SEPARATOR.'smartbill_sincronizare_stocuri.log';
        if(file_exists($file)){
            $format_message=date('Y-m-d H:i:sO').";".$type.";".json_encode($message).PHP_EOL;
            error_log($format_message,3, $file);
        }
    }

}